/* March 30, 2019 */
/* Usage elp N n < Sfile     K_N, n terminals, S vector in Sfile */
#include <stdio.h>
#include <stdlib.h>
/* generate CPLEX lp file to test an S vector for realizability */

int N,M,E,n;            /* max N is 10 */
int A[50][50];
int position=0;
int col[10000];      /* column location of subset I when converted to integer */
int maxedge=0;       /* max edge weight in realization, max S(I) value will work */

int power(int base, int exponent)
 {
         int result, i;

         result = 1;
         for (i = 0; i < exponent; i++)
                 result = result * base;

         return result;
 }


    /*  Function to generate combination  */
    void combinationUtil(int arr[], int data[], int start, int end, int index, int r, int n)

    {
        int j, i;
        int binary[10000];
        int ind;
        // Current combination is ready to be printed, print it
        for(i=1;i<=n;i++)
            binary[i]=0;
        ind=0;
        if (index == r) {
            for (j = 0; j < r; j++)
               {
             /*   printf("%d ", data[j]); */
                ind=ind+power(2,data[j]-1);
                binary[data[j]]=1;
               }
        position++;
        col[ind]=position;
            return;
        }
    
        // replace index with all possible elements. The condition
        // "end-i+1 >= r-index" makes sure that including one element
        // at index will make a combination with remaining elements
        // at remaining positions
        for (i = start; i <= end && end - i + 1 >= r - index; i++)
        {
            data[index] = arr[i];
            combinationUtil(arr, data, i + 1, end, index + 1, r, n);
        }
    }
    /*  End of combinationutil()  */

   /*  Function to print the combination  */
    void printCombination(int arr[], int n, int r)
    {
        int data[r];
        combinationUtil(arr, data, 0, n - 1, 0, r,n);
    }
    /*  End of printCombination()  */


static int read_graph (char *fname);

int main (int ac, char **av)
{
    int i, ii, j, k,  h, head, ind, it,cutsize;
    int Scount=0;
    int binary[5000];
    int y[5000];
    int arr[50000], r;
    int S[5000];
    int testS=0;

    if (ac <= 2)
     {
      printf("\nUsage: elp N n < Sfile , N>n");
      return 1;
     }  
    N=atoi(av[1]);
    n=atoi(av[2]);

/* read the S vector */

    for (i = 1; i <= power(2,n)-1; i++) 
      {
       scanf("%d",&S[i]);
       if(S[i] > maxedge)
          maxedge = S[i];
      }

    for (i = 0; i < 5000; i++) y[i] = 1;  /*counters of binary variables/

    if(N<n) 
     {
      printf("\nUsage: he N n [1] , N>n");
      return 1;
     }  
/* generate column indices for I */
        for (i = 0; i < n; i++)
        {
        arr[i]=i+1;
        }
        for (r = 1; r <= n; r++)
            printCombination(arr, n, r);

/* setup complete graph */

    for (i=0;i<N;i++)
       for (j=0;j<N;j++)
          A[i][j]= (i!=j);

    E=N*(N-1)/2+power(2,n);

    

    M=power(2,N-1);    /* 2**(N-1) */
    printf("\nMaximize");
    printf("\nobj: S1 ");
    printf("\nSubject to ");

/* fix S values */
   for(i=0;i<power(2,n)-1;i++)
     printf("\nS%d = %d",i+1,S[i+1]);

     printf("\n");
/* rows have to be adjusted for removing cuts with no terminals, ie. ind=0 */
    for (i = 0; i < 20; i++) binary[i] = 0;

    for (j=1;j<M;j++)
      {
      k=j;
      for (i=0;i<N;i++)
        {
         binary[i]=k % 2;
/*       printf(" %d",binary[i]);  */ 
         k=k/2;
        }

      ind=0;       /* offset for terminal -1 entry */
      for (i=0;i<n;i++)
           ind=ind+binary[i]*power(2,i);
      ind=col[ind];   /* use precomputed column location */

/* columns for terminals come first */
      for(ii=0;ii<power(2,n)-1;ii++)
          if(ii==ind-1)
           {
             cutsize=0;
             printf("\n S%d",ii+1);

/* now come the cut incidence vectors */
             for(i=0;i<N-1;i++)
             for (k=i+1;k<N;k++)
             {
                h=(binary[i]^binary[k]);
                if(A[i][k] && h==1)
                  {
                   cutsize++;
                   printf(" - x%d_%d",i+1,k+1);
                  }
             }
             printf(" <= 0");
           }
/* Now we do it again for the lowerbounds on S
/* columns for terminals come first */
      for(ii=0;ii<power(2,n)-1;ii++)
          if(ii==ind-1)
           {
             printf("\n %d y%d_%d + S%d",maxedge*cutsize,ii+1,y[ii+1],ii+1);
             y[ii+1]++;

/* now come the cut incidence vectors */
             for(i=0;i<N-1;i++)
               for (k=i+1;k<N;k++)
             {
               h=(binary[i]^binary[k]);
               if(A[i][k] && h==1)
                  printf(" - x%d_%d",i+1,k+1);
             }
             printf(" >= 0");
           }
           
    }

   printf("\n");
/* equations for binary variables */

   for(i=0;i<power(2,n)-1;i++)
    {
     printf("\n");
     for(k=1;k<y[i+1];k++)
       printf(" +y%d_%d",i+1,k);
     printf(" = %d",power(2,N-n-1)-1);
    }

   printf("\n\nBounds");

/*  nonnegativity constraints */
           
   for(i=0;i<N-1;i++)
        for (k=i+1;k<N;k++)
            printf("\n 0 <= x%d_%d <= %d",i+1,k+1,maxedge);

   printf("\n\nBinaries");
   for(i=0;i<power(2,n)-1;i++)
    {
     printf("\n");
     for(k=1;k<y[i+1];k++)
       printf(" y%d_%d",i+1,k);
    }

    printf("\nEnd\n");
    return 0;
}

